#include <Wire.h>
#include "RTClib.h"
#include <IRremote.h>

int RECV_PIN = 11;
int RELAY_PIN = 13;
int startTime = 1600; // lamp turns on at this time -- 1600 is 4pm.
int stopTime = 2200; // lamp turns off at this time -- preset for 2200 or 10pm.

RTC_Millis RTC;

IRrecv irrecv(RECV_PIN);
decode_results results;

void dump(decode_results *results) {
  int count = results->rawlen;
  if (results->decode_type == UNKNOWN) {
    Serial.println("Could not decode message");
  } 


  for (int i = 0; i < count; i++) {
    if ((i % 2) == 1) {
      Serial.print(results->rawbuf[i]*USECPERTICK, DEC);
    } 
    else {
      Serial.print(-(int)results->rawbuf[i]*USECPERTICK, DEC);
    }
    Serial.print(" ");
  }
  Serial.println("");
}

void setup()
{
      Serial.begin(57600);
    // following line sets the RTC to the date & time this sketch was compiled
    RTC.begin(DateTime(__DATE__, __TIME__));
  
  
  pinMode(RELAY_PIN, OUTPUT);
  pinMode(RECV_PIN, INPUT);
    Serial.begin(9600);
  irrecv.enableIRIn(); // Start the receiver
}

int on = 0;
unsigned long last = millis();

void loop() {
  
  
      DateTime now = RTC.now();
    
      int decimalTime = now.hour() * 100 + now.minute();
      Serial.print(decimalTime);
delay (1000);
    
    Serial.println();
    
        
    if (decimalTime == startTime) {
          digitalWrite(RELAY_PIN, HIGH);
    }
    
    if (decimalTime == stopTime) {
          digitalWrite(RELAY_PIN, LOW);
    }
  
  
  if (irrecv.decode(&results)) {
    // If it's been at least 1/4 second since the last
    // IR received, toggle the relay
    if (millis() - last > 250) {
      on = !on;
      digitalWrite(RELAY_PIN, on ? HIGH : LOW);
      dump(&results);


    }
    last = millis();      
    irrecv.resume(); // Receive the next value
    
  }
}
