// This code is based on Garrett Mace's example code on macetech.com.

int datapin  = 10; // DI
int latchpin = 11; // LI
int enablepin = 12; // EI
int clockpin = 13; // CI
int pspin = A1; // photo sensor
int sspin = A2; //sound sensor
int thspin = A3; //temperature and humidity sensor

int light = 0;  
int sound = 0;
int temp = 0;

unsigned long SB_CommandPacket;
int SB_CommandMode;
int SB_BlueCommand;
int SB_RedCommand;
int SB_GreenCommand;

void setup() {
   pinMode(datapin, OUTPUT);
   pinMode(latchpin, OUTPUT);
   pinMode(enablepin, OUTPUT);
   pinMode(clockpin, OUTPUT);
   pinMode(pspin, INPUT);
   pinMode(sspin, INPUT);

   digitalWrite(latchpin, LOW);
   digitalWrite(enablepin, LOW);
   
     Serial.begin(115200);          //  setup serial
     

}

void SB_SendPacket() {
   SB_CommandPacket = SB_CommandMode & B11;
   SB_CommandPacket = (SB_CommandPacket << 10)  | (SB_BlueCommand & 1023);
   SB_CommandPacket = (SB_CommandPacket << 10)  | (SB_RedCommand & 1023);
   SB_CommandPacket = (SB_CommandPacket << 10)  | (SB_GreenCommand & 1023);

   shiftOut(datapin, clockpin, MSBFIRST, SB_CommandPacket >> 24);
   shiftOut(datapin, clockpin, MSBFIRST, SB_CommandPacket >> 16);
   shiftOut(datapin, clockpin, MSBFIRST, SB_CommandPacket >> 8);
   shiftOut(datapin, clockpin, MSBFIRST, SB_CommandPacket);

   delay(1); 
   digitalWrite(latchpin,HIGH); 
   delay(1); 
   digitalWrite(latchpin,LOW);
}

void loop() {
  
 light = analogRead(pspin) + 50; // adjust tolerences here
 sound = analogRead(sspin) + 50; // adjust tolerences here
 temp = analogRead(thspin) / 50; // adjust tolerences here
 
   SB_CommandMode = B01; // Write to current control registers
   SB_RedCommand = 127; // Full current
   SB_GreenCommand = 127; // Full current
   SB_BlueCommand = 127; // Full current
   SB_SendPacket();

   delay(2500);

   SB_CommandMode = B00; // Write to PWM control registers
   SB_RedCommand = sound; 
   SB_GreenCommand = light; 
   SB_BlueCommand = temp; 
   SB_SendPacket();
   
       Serial.println("Light: ");
        Serial.println(light);
       Serial.println("Sound: ");
        Serial.println(sound);
       Serial.println("Temp: ");
        Serial.println(temp);  
}

